#ifndef IPXSTACK_H
#define IPXSTACK_H

#define OPEN_SOCKET     1
#define OPEN_STREAM     2
#define OPEN_SPX_SOCKET 3
#define CLOSE_SOCKET    4

#define NO_ERROR            0
#define ERROR_SOCKET_OPENED 1
/*
 * Client sends struct to ipxstack on its socket. Ipxstack opens a new socket for 
 * clients communication with network.
 */
typedef struct ipx_request ipx_request_t;
struct ipx_request {
  uint16_t request_type;
  uint16_t src_socket;
  uint32_t dest_net;
  uint16_t dest_node[3];
  uint16_t dest_socket;
  uint32_t pid;
} __attribute__((__packed__, aligned(1)));

/*
 * Ipxstack responds to the clients's request to open new connection. It sends
 * struct containing info about connection socket.
 */
typedef struct ipx_response ipx_response_t;
struct ipx_response {
  uint16_t src_socket;
  char socket_name[100];
  uint32_t pid;
  uint16_t error;
} __attribute__((__packed__, aligned(1)));

#endif /* IPXSTACK_H */
